Description

Mysql DB version: 5.1.73-14

migrating from 1.3.2-1 to 1.4.0-1 gives this error:

[root@foreman_server foreman]# foreman-rake --trace db:migrate

Invoke db:migrate (first_time)

Invoke environment (first_time)

Execute environment

Invoke db:load_config (first_time)

Execute db:load_config

Execute db:migrate

AllowNullValuesOnFactValue: migrating ===================================

-- change_column(:fact_values, :value, :text, {:null=>true})

rake aborted!

An error has occurred, all later migrations canceled:

Mysql2::Error: BLOB/TEXT column 'value' can't have a default value: ALTER TABLE `fact_values` CHANGE `value` `value` text

DEFAULT ''

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:245:i

n `query'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:245:i

n `block in execute'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:280:in

`block in log'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/notifications/instrumenter.rb:20:in `instrument'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:275:in `log'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:245:i

n `execute'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/mysql2_adapter.rb:211:in

`execute'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:480:i

n `change_column'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:466:in `block in method_missing'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:438:in `block in say_with_time'

/opt/rh/ruby193/root/usr/share/ruby/benchmark.rb:280:in `measure'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:438:in `say_with_time'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:458:in `method_missing'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:334:in `method_missing'

/usr/share/foreman/db/migrate/20131017142515_allow_null_values_on_fact_value.rb:3:in `up'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:370:in `up'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:410:in `block (2 levels) in migrate'

/opt/rh/ruby193/root/usr/share/ruby/benchmark.rb:280:in `measure'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:410:in `block in migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/connection_pool.rb:123:

in `with_connection'
/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:389:in `migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:528:in `migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:720:in `block (2 levels) in migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:777:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:777:in `ddl_transaction'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:719:in `block in migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:700:in `each'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:700:in `migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:570:in `up'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/migration.rb:551:in `migrate'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/railties/databases.rake:153:in `block (2 levels) in <top

(required)>'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:205:in `call'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:205:in `block in execute'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:200:in `each'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:200:in `execute'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:158:in `block in invoke_with_call_chain'

/opt/rh/ruby193/root/usr/share/ruby/monitor.rb:211:in `mon_synchronize'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:151:in `invoke_with_call_chain'

/opt/rh/ruby193/root/usr/share/ruby/rake/task.rb:144:in `invoke'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:116:in `invoke_task'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:94:in `block (2 levels) in top_level'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:94:in `each'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:94:in `block in top_level'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:133:in `standard_exception_handling'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:88:in `top_level'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:66:in `block in run'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:133:in `standard_exception_handling'

/opt/rh/ruby193/root/usr/share/ruby/rake/application.rb:63:in `run'

/opt/rh/ruby193/root/usr/bin/rake:32:in `<main>'

Tasks: TOP => db:migrate

History

#1 - 02/11/2014 03:08 PM - Dominic Cleal

Can you provide any more info about your MySQL server?  I'm just reading this web page and it suggests it's only seen on Windows MySQL servers: 

http://stackoverflow.com/a/4553664/146925

#2 - 02/11/2014 03:17 PM - Craig Cook

Percona Server on Scientific Linux 6.4.

#3 - 02/12/2014 02:13 PM - Craig Cook

Looks like TEXT fields cannot have default values:

http://dev.mysql.com/doc/refman/5.1/en/blob.html

"BLOB and TEXT columns cannot have DEFAULT values. "

#4 - 06/03/2014 05:48 PM - Alex Leonhardt

I have this very same issue just now, any ideas how to fix ?

Alex

#5 - 06/03/2014 06:04 PM - Alex Leonhardt

Hi,

our DBA just figured out what it is. When STRICT mode is enabled, it won't allow the migration job to set a default on that column (possibly because

there is already data in there). A way to get around this is to temporarily change the DB back to "traditional".

http://dev.mysql.com/doc/refman/5.0/en/sql-mode.html#sql-mode-strict

Alex

#6 - 11/24/2019 10:23 AM - Tomer Brisker

- Status changed from New to Rejected
http://stackoverflow.com/a/4553664/146925
http://dev.mysql.com/doc/refman/5.1/en/blob.html
http://dev.mysql.com/doc/refman/5.0/en/sql-mode.html#sql-mode-strict


Support for MySQL is being dropped in Foreman 2.0. Please migrate to PostgreSQL - see 

https://theforeman.org/2019/09/dropping-support-for-mysql.html for more details.
